<html>
<head>
<title>OgreDistanceLodStrategy.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreDistanceLodStrategy.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreDistanceLodStrategy_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __Distance_Lod_Strategy_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __Distance_Lod_Strategy_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreLodStrategy_8h.html">OgreLodStrategy.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreSingleton_8h.html">OgreSingleton.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreNode_8h.html">OgreNode.h</a>&quot;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="keyword">namespace </span>Ogre {
<a name="l00046"></a><a class="code" href="classOgre_1_1DistanceLodStrategy.html">00046</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1DistanceLodStrategy.html" title="Level of detail strategy based on distance from camera.">DistanceLodStrategy</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1LodStrategy.html" title="Strategy for determining level of detail.">LodStrategy</a>, <span class="keyword">public</span> <a class="code" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a>&lt;DistanceLodStrategy&gt;
<a name="l00047"></a>00047     {
<a name="l00048"></a>00048     <span class="keyword">protected</span>:
<a name="l00050"></a>00050         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getValueImpl(<span class="keyword">const</span> <a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a> *movableObject, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a> *camera) <span class="keyword">const</span>;
<a name="l00051"></a>00051 
<a name="l00052"></a>00052     <span class="keyword">public</span>:
<a name="l00054"></a>00054         <a class="code" href="classOgre_1_1DistanceLodStrategy.html" title="Level of detail strategy based on distance from camera.">DistanceLodStrategy</a>();
<a name="l00055"></a>00055 
<a name="l00057"></a>00057         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getBaseValue() <span class="keyword">const</span>;
<a name="l00058"></a>00058 
<a name="l00060"></a>00060         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> transformBias(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> factor) <span class="keyword">const</span>;
<a name="l00061"></a>00061 
<a name="l00063"></a>00063         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> transformUserValue(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> userValue) <span class="keyword">const</span>;
<a name="l00064"></a>00064 
<a name="l00066"></a>00066         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> getIndex(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> value, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Mesh.html#afe83b164df6c330c0bd7b7c5c76d04e3">Mesh::MeshLodUsageList</a>&amp; meshLodUsageList) <span class="keyword">const</span>;
<a name="l00067"></a>00067 
<a name="l00069"></a>00069         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> getIndex(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> value, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Material.html#a4c0945a06c098b9b1d366d9d3ba857fe" title="distance list used to specify LOD">Material::LodValueList</a>&amp; materialLodValueList) <span class="keyword">const</span>;
<a name="l00070"></a>00070 
<a name="l00072"></a>00072         <span class="keyword">virtual</span> <span class="keywordtype">void</span> sort(<a class="code" href="classOgre_1_1Mesh.html#afe83b164df6c330c0bd7b7c5c76d04e3">Mesh::MeshLodUsageList</a>&amp; meshLodUsageList) <span class="keyword">const</span>;
<a name="l00073"></a>00073 
<a name="l00075"></a>00075         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> isSorted(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Mesh.html#a7d726e72a87c304798883fbecbe6810a">Mesh::LodValueList</a>&amp; values) <span class="keyword">const</span>;
<a name="l00076"></a>00076 
<a name="l00084"></a>00084         <span class="keywordtype">void</span> setReferenceView(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> viewportWidth, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> viewportHeight, <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a> fovY);
<a name="l00085"></a>00085 
<a name="l00089"></a>00089         <span class="keywordtype">void</span> setReferenceViewEnabled(<span class="keywordtype">bool</span> value);
<a name="l00090"></a>00090 
<a name="l00092"></a>00092         <span class="keywordtype">bool</span> getReferenceViewEnabled() <span class="keyword">const</span>;
<a name="l00093"></a>00093 
<a name="l00109"></a>00109         <span class="keyword">static</span> <a class="code" href="classOgre_1_1DistanceLodStrategy.html" title="Level of detail strategy based on distance from camera.">DistanceLodStrategy</a>&amp; getSingleton(<span class="keywordtype">void</span>);
<a name="l00125"></a>00125         <span class="keyword">static</span> <a class="code" href="classOgre_1_1DistanceLodStrategy.html" title="Level of detail strategy based on distance from camera.">DistanceLodStrategy</a>* getSingletonPtr(<span class="keywordtype">void</span>);
<a name="l00126"></a>00126 
<a name="l00127"></a>00127     <span class="keyword">private</span>:
<a name="l00128"></a><a class="code" href="classOgre_1_1DistanceLodStrategy.html#ae9eb821935684ef28be3095208985e1f">00128</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1DistanceLodStrategy.html#ae9eb821935684ef28be3095208985e1f">mReferenceViewEnabled</a>;
<a name="l00129"></a><a class="code" href="classOgre_1_1DistanceLodStrategy.html#a03fc36553715fa45072c777041a1f17a">00129</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1DistanceLodStrategy.html#a03fc36553715fa45072c777041a1f17a">mReferenceViewValue</a>;
<a name="l00130"></a>00130 
<a name="l00131"></a>00131     };
<a name="l00135"></a>00135 } <span class="comment">// namespace</span>
<a name="l00136"></a>00136 
<a name="l00137"></a>00137 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
